Attribute VB_Name = "PrintModelReportModule"
Option Explicit
Dim theForm As Exe1Form
Dim server As RMSServer
Dim session As RMSSession
Dim client As RMSClient
Dim model As RMSModel
Dim theUMLModel As UMLModel
Dim theDictionary As Object
Dim theInverseDictionary As Object
    

Sub WriteToForm(theLine As String)
    theForm.Text2 = theForm.Text2 + Chr(13) + Chr(10) + theLine
End Sub

Sub InitializeModel(theFilename As String, aForm As Exe1Form)
    Set theForm = aForm
    'Create our own server, session and client
    Set server = New RMSServer

    Set session = server.CreateSession()
    Set client = session.CreateClient("name", "desc", "noop", 0)
    
    'Open RMSModel

    Set model = session.OpenModel(theFilename)
    
    'Open read action around access to model info
    client.StartAction RMS_LOCK_MODE_READ, "desc", "0"
    WriteToForm "Opening Model File: " & model.RootPath
    
    'Open UMLModel

    Set theUMLModel = model.root


End Sub
Sub Cleanup()
    If Not client Is Nothing Then
    'close read action
    client.CompleteAction
    'A little more session management
    client.Close
    session.Close
    Set server = Nothing
    End If
End Sub



Sub BuildUCList()
    Dim i As Integer
    
    Set theDictionary = CreateObject("Scripting.Dictionary")
    Set theInverseDictionary = CreateObject("Scripting.Dictionary")
    Call GetAllUCs(theUMLModel)

    Dim a As Variant
    a = theDictionary.Items
    
    For i = LBound(a) To UBound(a)
        theForm.UCList.AddItem (a(i))
    Next i
    
End Sub

Sub PrintUCPartecipants(thestring As String)
    Dim theGuid As String
    Dim theUC As UMLUseCase
    Dim theElem As RMSElement
    Dim theSelectedEl As RMSElement
    Dim thecollab As UMLCollaboration
    Dim theRoles As RMSElements
    Dim theRole As UMLClassifierRole
    Dim theEl As IUMLNamedModelElement
    Dim theobjects As RMSElements
    Dim theCollabInstance As UMLCollaborationInstance
    Dim theObj As UMLObject
    Dim theclassifier As UMLClassifierRole
    Dim thecls As RMSElement
    Dim theClsDictionary As Object
    Set theClsDictionary = CreateObject("Scripting.Dictionary")
    Dim i As Integer, j As Integer
    
    theGuid = theInverseDictionary.Item(thestring)
    Set theSelectedEl = model.FindElementWithGuidStr(theGuid)
    Set theUC = model.FindElementWithGuidStr(theGuid)
    WriteToForm ""
    WriteToForm "Selected Use Case: " + theSelectedEl.GetFullyQualifiedName(True)
    
    Dim thecollabs As RMSElements
    
    Set thecollabs = theUC.GetCollaborations

    For i = 1 To thecollabs.Count
      Set theElem = thecollabs.Item(i)

      If (theElem.LanguageElement.Name = "Collaboration") Then
        Set thecollab = thecollabs.Item(i)

        Set theRoles = thecollab.GetClassifierRoles
        For j = 1 To theRoles.Count
            Set theRole = theRoles.Item(j)
            'WriteToForm CStr(theRole.Base.Kind)
            If (theRole.Base.Kind = RMS_REF_RESOLVED Or theRole.Base.Kind = RMS_REF_RESOLVED_WITH_CORRECTION) Then
                'WriteToForm "  Classifier Role: " + theRole.Name + " : " + theRole.Base.TargetName
                Set thecls = theRole.Base.Resolve
                If Not theClsDictionary.Exists(thecls.IdStr) Then
                theClsDictionary.Add thecls.IdStr, thecls.GetFullyQualifiedName(True)
                WriteToForm theRole.Base.TargetName + " (" + theRole.Base.Resolve.LanguageElement.Name + ")"
                'a class may be taken from one diagram but its other operations may be used on another diagram
                Call PrintOperationsInUC(thecls, theUC)
                End If
             End If
            
        Next j
        
       Else
        Set theCollabInstance = thecollabs.Item(i)
        Set theobjects = theCollabInstance.GetInstances
        For j = 1 To theobjects.Count
            Set theObj = theobjects.Item(j)
            'WriteToForm "  Object: " + theObj.Name + " : " + theObj.InstanceOf.TargetName
            'WriteToForm CStr(theObj.InstanceOf.Kind)
            If (theObj.InstanceOf.Kind = RMS_REF_RESOLVED Or theObj.InstanceOf.Kind = RMS_REF_RESOLVED_WITH_CORRECTION) Then
                
                Set thecls = theObj.InstanceOf.Resolve
                If Not theClsDictionary.Exists(thecls.IdStr) Then
                theClsDictionary.Add thecls.IdStr, thecls.GetFullyQualifiedName(True)
                WriteToForm theObj.InstanceOf.TargetName + " (" + theObj.InstanceOf.Resolve.LanguageElement.Name + ")"
                
                Call PrintOperationsInUC(thecls, theUC)
                End If
            End If
            
        Next j
       End If
    Next i
    
End Sub

Sub GetAllUCs(root As IUMLNamedModelElement)
    'WriteToForm root.Name
    Dim rootelem As RMSElement
    Set rootelem = root

    Dim pkgs As RMSElements
    Dim pkg As UMLPackage
    Dim thesubs As RMSElements
    Dim thesubel As RMSElement
    Dim thesub As UMLSubsystem
    Dim i As Integer
    
    If (rootelem.LanguageElement.Name = "Package" Or rootelem.LanguageElement.Name = "Model") Then
        Dim rootpkg As UMLPackage
        Set rootpkg = root
        Call ADDUCsFromPackage(root)
        'Get all child packages
        Set pkgs = rootpkg.GetNestedPackages

        For i = 1 To pkgs.Count
            Set pkg = pkgs.Item(i)
            Call GetAllUCs(pkg)
        Next i
        'get all child subsystems

        Set thesubs = rootpkg.GetClassifiers
        
        For i = 1 To thesubs.Count
            Set thesubel = thesubs.Item(i)
            If thesubel.LanguageElement.Name = "Subsystem" Then
                Set thesub = thesubs.Item(i)
                Call GetAllUCs(thesub)
            End If
        Next i
    End If
    If rootelem.LanguageElement.Name = "Subsystem" Then
        Dim rootsub As UMLSubsystem
        Set rootsub = root
        Call ADDUCsFromSubsystem(root)
        'Get all child packages

        Set pkgs = rootsub.GetNestedPackages

        For i = 1 To pkgs.Count
            Set pkg = pkgs.Item(i)
            Call GetAllUCs(pkg)
        Next i
        'get all child subsystems

        Set thesubs = rootsub.GetNestedClassifiers
        
        For i = 1 To thesubs.Count
            Set thesubel = thesubs.Item(i)
            If thesubel.LanguageElement.Name = "Subsystem" Then
                Set thesub = thesubs.Item(i)
                Call GetAllUCs(thesub)
            End If
        Next i
    End If
End Sub

Sub ADDUCsFromPackage(thePkg As UMLPackage)
    Dim i As Integer
    Dim theClassifiers As RMSElements
    Dim theEl As RMSElement
    Set theClassifiers = thePkg.GetClassifiers()
    For i = 1 To theClassifiers.Count
        Set theEl = theClassifiers.Item(i)
        If (theEl.LanguageElement.Name = "UseCase") Then
            theDictionary.Add theEl.IdStr, theEl.Name + " (" + theEl.GetFullyQualifiedName(True) + ")"
            theInverseDictionary.Add theEl.Name + " (" + theEl.GetFullyQualifiedName(True) + ")", theEl.IdStr
            'WriteToForm theEl.GetFullyQualifiedName(True)
        End If
    Next i
End Sub
Sub ADDUCsFromSubsystem(thePkg As UMLSubsystem)
    Dim i As Integer
    Dim theClassifiers As RMSElements
    Dim theEl As RMSElement
    Set theClassifiers = thePkg.GetNestedClassifiers()
    For i = 1 To theClassifiers.Count
        Set theEl = theClassifiers.Item(i)
        If (theEl.LanguageElement.Name = "UseCase") Then
            theDictionary.Add theEl.IdStr, theEl.Name + " (" + theEl.GetFullyQualifiedName(True) + ")"
            theInverseDictionary.Add theEl.Name + " (" + theEl.GetFullyQualifiedName(True) + ")", theEl.IdStr
            'WriteToForm theEl.GetFullyQualifiedName(True)
        End If
    Next i
End Sub

Sub PrintOperationsInUC(thecls As IUMLClassifier, theUC As UMLUseCase)
    Dim theOpDictionary As Object
    Set theOpDictionary = CreateObject("Scripting.Dictionary")
    
    Dim op As UMLOperation
    Dim theopel As RMSElement
    
    Dim opColl As RMSElements
    Dim theCollabInstance As UMLCollaborationInstance
    Dim thecollab As UMLCollaboration
    
    Dim i As Integer, j As Integer, k As Integer
    Dim theReturn As String
    Dim thePar As UMLParameter
    
    Set opColl = thecls.GetOperations
    
    For i = 1 To opColl.Count
        Set op = opColl.Item(i)
        Set theopel = op
        For k = 1 To theUC.GetCollaborations.Count
          If theUC.GetCollaborations.Item(k).LanguageElement.Name = "Collaboration" Then
            Set thecollab = theUC.GetCollaborations.Item(k)
            If (Not theOpDictionary.Exists(theopel.IdStr) And CollaborationContainsOperation(op, thecollab)) Then
               theOpDictionary.Add theopel.IdStr, theopel.GetFullyQualifiedName(True)
               WriteToForm "    Operation: " & op.Name
               For j = 1 To op.GetParameters.Count
                 Set thePar = op.GetParameters.Item(j)
                 If thePar.Kind = UML_PARAMETERDIRECTIONKIND_RETURN Then
                   WriteToForm "        Return: " & _
                   thePar.Name & " Type: " & thePar.TypeExpression
                 Else
                   WriteToForm "        Parameter: " & _
                   thePar.Name & " Type: " & thePar.TypeExpression
                 End If
               Next j
           End If
          Else
           Set theCollabInstance = theUC.GetCollaborations.Item(k)
           If (Not theOpDictionary.Exists(theopel.IdStr) And CollabInstanceContainsOperation(op, theCollabInstance)) Then
             theOpDictionary.Add theopel.IdStr, theopel.GetFullyQualifiedName(True)
             WriteToForm "    Operation: " & op.Name
             For j = 1 To op.GetParameters.Count
               Set thePar = op.GetParameters.Item(j)
               If thePar.Kind = UML_PARAMETERDIRECTIONKIND_RETURN Then
                 WriteToForm "        Return: " & _
                 thePar.Name & " Type: " & thePar.TypeExpression
                Else
                  WriteToForm "        Parameter: " & _
                  thePar.Name & " Type: " & thePar.TypeExpression
                End If
             Next j
          End If 'if the operation does not already exist
          End If
        Next k

    Next i
    
    Set theOpDictionary = Nothing
End Sub


Function CollabInstanceContainsOperation(theop As IUMLOperation, theCollabInstance As UMLCollaborationInstance) As Boolean
    Dim i As Integer, j As Integer
    Dim theinteraction As UMLInteractionInstance
    Dim themessages As RMSElements
    Dim themess As UMLStimulus
    Dim theaction As RMSElement
    Dim theCall As UMLCallAction
    Dim theref As RMSReference
    Dim thetargetguid As String
    Dim theopel As RMSElement
    Dim found As Boolean
    found = False
    
    
    Set theopel = theop
    For i = 1 To theCollabInstance.GetInteractionInstances.Count
        Set theinteraction = theCollabInstance.GetInteractionInstances.Item(i)
        Set themessages = theinteraction.GetStimuli
        For j = 1 To themessages.Count
            Set themess = themessages.Item(j)
            Set theaction = themess.Action
            If theaction.LanguageElement.Name = "CallAction" Then
                Set theCall = theaction
                Set theref = theCall.CalledOperation
                If theref.Kind = RMS_REF_RESOLVED Or RMS_REF_RESOLVED_WITH_CORRECTION Then
                    thetargetguid = theref.TargetGuidStr
                    If (thetargetguid = theopel.IdStr) Then
                        found = True
                    End If
                End If
                
            End If
        Next j
    Next i
    CollabInstanceContainsOperation = found
End Function


Function CollaborationContainsOperation(theop As IUMLOperation, theCollaboration As UMLCollaboration) As Boolean
    Dim i As Integer, j As Integer
    Dim theinteraction As UMLInteraction
    Dim themessages As RMSElements
    Dim themess As UMLMessage
    Dim theaction As RMSElement
    Dim theCall As UMLCallAction
    Dim theref As RMSReference
    Dim thetargetguid As String
    Dim theopel As RMSElement
    Dim found As Boolean
    found = False
    
    
    Set theopel = theop
    For i = 1 To theCollaboration.GetInteractions.Count
        Set theinteraction = theCollaboration.GetInteractions.Item(i)
        Set themessages = theinteraction.GetMessages
        For j = 1 To themessages.Count
            Set themess = themessages.Item(j)
            Set theaction = themess.Action
            If theaction.LanguageElement.Name = "CallAction" Then
                Set theCall = theaction
                Set theref = theCall.CalledOperation
                If theref.Kind = RMS_REF_RESOLVED Or RMS_REF_RESOLVED_WITH_CORRECTION Then
                    thetargetguid = theref.TargetGuidStr
                    If (thetargetguid = theopel.IdStr) Then
                        found = True
                    End If
                End If
                
            End If
        Next j
    Next i
    CollaborationContainsOperation = found
End Function

